#include <stdio.h>	
#include <Windows.h>
#include "Serial.h"

void SERIAL (int serial_port, int baud_rate, int samples, int sampling_interval, int bytes_perFrame) {
 char Data[]= {"@"}, receive_buf[4096], X_ayis[10]; // X_axis holds loop counter in string format 
 int Data_length=sizeof(Data)/sizeof(char), loop, rxBytes, txBytes, gnuplotWindow=25;
 fclose(stderr);
 FILE *fp, *pipe, *fpGNUPLOT;
 fp = fopen("measurements.txt","a"); 
 fclose(fp);
 fp = fopen("measurements.txt","r+"); 
 fseek (fp, 0, SEEK_END); 					 			    
 pipe = popen("gnuplot -persist","w"); // keeps the plot open  
 fpGNUPLOT = fopen("Pressure.dat","w"); 
 fclose(fpGNUPLOT); 
 
  if (SERIAL_Open(serial_port, baud_rate)) exit(0);
  txBytes = SERIAL_Write(Data, Data_length-1); 
  Sleep(1000);
  for (loop=0; loop<samples; loop++) {
   rxBytes = SERIAL_Read(receive_buf, bytes_perFrame);
   if (rxBytes==0) { // if bytes not received, repeat current iteration
	   --loop;
	   continue;
   }
   printf(" loop%d: rxBytes=%d",loop,rxBytes);
   receive_buf[bytes_perFrame-2]='\0'; 		/*revised for gnuplot: remove 0x0D,0x0D characters*/
   printf(" receive_buf=%s\n",receive_buf); /*revised for gnuplot: print '\n' character*/
   fprintf(fp,"%s",receive_buf);  
    // Print to GNUPLOT
    sprintf(X_ayis, "%d", loop); //  loop counter in numeric string (X_axis)
    fpGNUPLOT = fopen("Pressure.dat","a"); 
    //if(loop>gnuplotWindow)	fprintf(pipe, "set xrange [%d:%d]\n",loop-(gnuplotWindow-1), loop);
    fprintf(fpGNUPLOT,"%s %s\n",X_ayis,receive_buf);  // recive_buf in Y_axis
    fprintf(pipe, "plot  '%s' with lines linecolor 'red' lw 2; unset key\n","Pressure.dat");
    fclose(fpGNUPLOT);  
    fflush(pipe); // flush the pipe to update plot
   Sleep(sampling_interval);
  }
  SERIAL_Close(); 
 fclose(fp);  
 fclose(pipe);
}

int main()
{
	int P_samples = 100, ODR=100 , frame_bytes=10;
	SERIAL (55, 9600/*gnuplot@9600*/, P_samples, ODR, frame_bytes); // Teensy on COM55
return(0);
}
